<?php 
if( function_exists('acf_add_local_field_group') ):

acf_add_local_field_group(array (
	'key' => 'group_569653f31f73f',
	'title' => 'WooCommerce Shipping Tracking - Estimated shippings settings',
	'fields' => array (
		array (
			'key' => 'field_569654370dfbf',
			'label' => 'Hour offset',
			'name' => 'wcst_hour_offset',
			'type' => 'number',
			'instructions' => 'If server time is different from yours,	adjust the "Hour offset" value to syncronize it with your time. If you don\'t know server time, use the widget added by this plugin in the Wordpress Dashboard',
			'required' => 0,
			'conditional_logic' => 0,
			'wrapper' => array (
				'width' => '',
				'class' => '',
				'id' => '',
			),
			'default_value' => 0,
			'placeholder' => '',
			'prepend' => '',
			'append' => '',
			'min' => -12,
			'max' => 12,
			'step' => 1,
			'readonly' => 0,
			'disabled' => 0,
		),
		array (
			'key' => 'field_5696545e0dfc0',
			'label' => 'Estimation rules',
			'name' => 'wcst_shippings',
			'type' => 'repeater',
			'instructions' => '',
			'required' => 0,
			'conditional_logic' => 0,
			'wrapper' => array (
				'width' => '',
				'class' => '',
				'id' => '',
			),
			'collapsed' => 'field_569654b40dfc1',
			'min' => '',
			'max' => '',
			'layout' => 'row',
			'button_label' => 'Add rule',
			'sub_fields' => array (
				array (
					'key' => 'field_569654b40dfc1',
					'label' => 'Name / id',
					'name' => 'wcst_name_id',
					'type' => 'text',
					'instructions' => '',
					'required' => 1,
					'conditional_logic' => 0,
					'wrapper' => array (
						'width' => '',
						'class' => '',
						'id' => '',
					),
					'default_value' => '',
					'placeholder' => '',
					'prepend' => '',
					'append' => '',
					'maxlength' => '',
					'readonly' => 0,
					'disabled' => 0,
				),
				array (
					'key' => 'field_5697d924cd8c4',
					'label' => 'Products',
					'name' => 'wcst_products',
					'type' => 'post_object',
					'instructions' => '',
					'required' => 0,
					'conditional_logic' => 0,
					'wrapper' => array (
						'width' => '',
						'class' => '',
						'id' => '',
					),
					'post_type' => array (
						0 => 'product',
					),
					'taxonomy' => array (
					),
					'allow_null' => 1,
					'multiple' => 1,
					'return_format' => 'id',
					'ui' => 1,
				),
				array (
					'key' => 'field_5697d952cd8c5',
					'label' => 'Categories',
					'name' => 'wcst_categories',
					'type' => 'taxonomy',
					'instructions' => '',
					'required' => 0,
					'conditional_logic' => 0,
					'wrapper' => array (
						'width' => '',
						'class' => '',
						'id' => '',
					),
					'taxonomy' => 'product_cat',
					'field_type' => 'multi_select',
					'allow_null' => 1,
					'add_term' => 1,
					'save_terms' => 0,
					'load_terms' => 0,
					'return_format' => 'id',
					'multiple' => 0,
				),
				array (
					'key' => 'field_5698b3440f660',
					'label' => 'Children categories',
					'name' => 'wcst_children_categories',
					'type' => 'radio',
					'instructions' => 'If at least one category has been selected, you can assign the estimation rule also to children categories items',
					'required' => 0,
					'conditional_logic' => 0,
					'wrapper' => array (
						'width' => '',
						'class' => '',
						'id' => '',
					),
					'choices' => array (
						'selected_only' => 'Apply to selected categories only',
						'all_children' => 'Apply to selected categories and all its children',
					),
					'other_choice' => 0,
					'save_other_choice' => 0,
					'default_value' => 'selected_only',
					'layout' => 'vertical',
				),
				array (
					'key' => 'field_569660bfddfa1',
					'label' => 'Working days',
					'name' => 'wcst_working_days',
					'type' => 'checkbox',
					'instructions' => '',
					'required' => 1,
					'conditional_logic' => 0,
					'wrapper' => array (
						'width' => '',
						'class' => '',
						'id' => '',
					),
					'choices' => array (
						1 => 'Monday',
						2 => 'Tuesday',
						3 => 'Wednesday',
						4 => 'Thrusday',
						5 => 'Friday',
						6 => 'Saturday',
						0 => 'Sunday',
					),
					'default_value' => array (
					),
					'layout' => 'vertical',
					'toggle' => 0,
				),
				array (
					'key' => 'field_56966147ddfa2',
					'label' => 'Cut-off hour',
					'name' => 'wcst_day_cut_off_hour',
					'type' => 'number',
					'instructions' => 'If an order is placed before this hour it will be shipped within the same day, othewise it will be shipped on the next avaiable date.',
					'required' => 0,
					'conditional_logic' => 0,
					'wrapper' => array (
						'width' => 48,
						'class' => '',
						'id' => '',
					),
					'default_value' => 0,
					'placeholder' => '',
					'prepend' => '',
					'append' => '',
					'min' => 0,
					'max' => 23,
					'step' => '',
					'readonly' => 0,
					'disabled' => 0,
				),
				array (
					'key' => 'field_5697d86fcd8c3',
					'label' => 'Days delay',
					'name' => 'wcst_days_delay',
					'type' => 'number',
					'instructions' => 'Shipment date will be the first working day available after the "delay value" days.',
					'required' => 0,
					'conditional_logic' => 0,
					'wrapper' => array (
						'width' => 48,
						'class' => '',
						'id' => '',
					),
					'default_value' => 0,
					'placeholder' => '',
					'prepend' => '',
					'append' => '',
					'min' => 0,
					'max' => 30,
					'step' => 1,
					'readonly' => 0,
					'disabled' => 0,
				),
				array (
					'key' => 'field_56966171ddfa3',
					'label' => 'Holidays / Non working days',
					'name' => 'wcst_non_working_days',
					'type' => 'repeater',
					'instructions' => 'Special days in which shipment cannot take place.',
					'required' => 0,
					'conditional_logic' => 0,
					'wrapper' => array (
						'width' => '',
						'class' => '',
						'id' => '',
					),
					'collapsed' => '',
					'min' => '',
					'max' => '',
					'layout' => 'table',
					'button_label' => 'Add Row',
					'sub_fields' => array (
						array (
							'key' => 'field_56966190ddfa4',
							'label' => 'Day',
							'name' => 'wcst_day',
							'type' => 'select',
							'instructions' => '',
							'required' => 1,
							'conditional_logic' => 0,
							'wrapper' => array (
								'width' => '',
								'class' => '',
								'id' => '',
							),
							'choices' => array (
								1 => 1,
								2 => 2,
								3 => 3,
								4 => 4,
								5 => 5,
								6 => 6,
								7 => 7,
								8 => 8,
								9 => 9,
								10 => 10,
								11 => 11,
								12 => 12,
								13 => 13,
								14 => 14,
								15 => 15,
								16 => 16,
								17 => 17,
								18 => 18,
								19 => 19,
								20 => 20,
								21 => 21,
								22 => 22,
								23 => 23,
								24 => 24,
								25 => 25,
								26 => 26,
								27 => 27,
								28 => 28,
								29 => 29,
								30 => 30,
								31 => 31,
							),
							'default_value' => array (
							),
							'allow_null' => 0,
							'multiple' => 0,
							'ui' => 0,
							'ajax' => 0,
							'placeholder' => '',
							'disabled' => 0,
							'readonly' => 0,
						),
						array (
							'key' => 'field_569661cdddfa5',
							'label' => 'Month',
							'name' => 'wcst_month',
							'type' => 'select',
							'instructions' => '',
							'required' => 1,
							'conditional_logic' => 0,
							'wrapper' => array (
								'width' => '',
								'class' => '',
								'id' => '',
							),
							'choices' => array (
								1 => 1,
								2 => 2,
								3 => 3,
								4 => 4,
								5 => 5,
								6 => 6,
								7 => 7,
								8 => 8,
								9 => 9,
								10 => 10,
								11 => 11,
								12 => 12,
							),
							'default_value' => array (
							),
							'allow_null' => 0,
							'multiple' => 0,
							'ui' => 0,
							'ajax' => 0,
							'placeholder' => '',
							'disabled' => 0,
							'readonly' => 0,
						),
					),
				),
			),
		),
	),
	'location' => array (
		array (
			array (
				'param' => 'options_page',
				'operator' => '==',
				'value' => 'acf-options-estimated-shipping-configurator',
			),
		),
	),
	'menu_order' => 0,
	'position' => 'normal',
	'style' => 'default',
	'label_placement' => 'top',
	'instruction_placement' => 'label',
	'hide_on_screen' => '',
	'active' => 1,
	'description' => '',
));

endif;
?>